#!/usr/bin/python

# license: wtfpl
# http://www.wtfpl.net/txt/copying/

import serial, sys, time


try:
    ser = serial.Serial("/dev/ttyACM0",115200,timeout=2)   # unter Windows: "com1" bis "com255"
    ser.flushInput()
except:
    print "-----> serial not found" 
    quit()

try:
    pyfile=open(sys.argv[1])   

except:
    print "file not found"
    quit()

allezeilen=pyfile.readlines()

print
print "***** fast micro:bit upload tool *****"
print "sending <ctrl-b> to end raw mode (if accidentaly activated before)"
ser.write(chr(2))
time.sleep(0.3)
print "sending <ctrl-c> to stop a running program"
ser.write(chr(3))
time.sleep(0.3)
print "sending reset() to delete an old program from memory"
ser.write("reset()\r") 
time.sleep(0.3)
print"sending <ctrl-a> to switch into raw repl mode"
ser.write(chr(1))
time.sleep(0.3)
print "transferring", pyfile, "to micro:bit"
 
for zeile in allezeilen:
    zeile_ohne = zeile.split(chr(10))
    ser.write(zeile_ohne[0])
    ser.write(chr(13))
#    print zeile
#    time.sleep(0.1)
    
print pyfile, "transferred to micro:bit"
pyfile.close()
print "soft resetting micro:bit by sending <ctrl-d>"
time.sleep(0.3)
ser.write(chr(4))
print "***** code should run now! ***********"
print

